package com.example.kafka.consumer;

import com.example.kafka.MessageStore;
import com.example.kafka.serviceImpl.UserServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;

@Component
public class MessageConsumer {
    @Autowired
    private MessageStore store;

    @Autowired
    private UserServiceImpl userService;

    @KafkaListener(topics = "${app.topic.name}",groupId = "group1")
    public void readMessage(String message){
        userService.validateOrder(message);
        store.addMessage(message);
    }   

}
