package com.example.kafka.serviceImpl;

import com.example.kafka.entity.Order;
import com.example.kafka.entity.User;
import com.example.kafka.repository.UserRepository;
import com.example.kafka.service.UserService;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.Map;

@Service
public class UserServiceImpl implements UserService {

    @Autowired
    private UserRepository userRepository;

    @Override
    public Mono<User> createUser(User user){
        return userRepository.save(user);
    }

    @Override
    public Flux<User> getAllUsers(){
        return userRepository.findAll();
    }

    @Override
    public Mono<User> findById(String userId){
        return userRepository.findById(userId);
    }

    @Override
    public Mono<User> updateUser(String userId,  User user){
        return userRepository.findById(userId)
                .flatMap(dbUser -> {
                    dbUser.setAge(user.getAge());
                    dbUser.setBalance(user.getBalance());
                    return userRepository.save(dbUser);
                });
    }

    @Override
    public void validateOrder(String message) {
        try {
            ObjectMapper mapper = new ObjectMapper();
            Map<String, Object> map = mapper.readValue(message, Map.class);

        } catch (Exception e) {
            System.out.println(e);
        }
    }
}
